"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@forms.js/core");
const vue_1 = require("vue");
const formData = (0, vue_1.ref)(null);
const FormComponent = (0, vue_1.defineComponent)({
    props: {
        options: {
            type: Object,
            required: true,
        },
        plugins: {
            type: Array,
            required: false,
            default: [],
        },
        licenseKey: {
            type: String,
            required: false,
            default: null,
        },
    },
    data() {
        return {
            formInstance: null,
            processedOptions: {},
        };
    },
    methods: {
        reset() {
            var _a;
            (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.reset();
        },
        validate() {
            var _a;
            (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.validate();
        },
        submit() {
            var _a;
            (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.submit();
        },
        getForm() {
            return this.formInstance;
        },
        getField(id) {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getField(id);
        },
        getGroup(id) {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getGroup(id);
        },
        getGroups() {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getGroups();
        },
        getButton(id) {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getButton(id);
        },
        getButtons() {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getButtons();
        },
        getData() {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getData();
        },
        getId() {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getId();
        },
        getFormElement() {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getFormElement();
        },
        isValid() {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.isValid();
        },
        getErrors() {
            var _a;
            return (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getErrors();
        },
        initForm() {
            return __awaiter(this, void 0, void 0, function* () {
                var _a, _b, _c, _d, _e;
                this.processedOptions = (yield this.resolveVNodes(Object.assign({}, this.$props.options)));
                this.formInstance = new core_1.Form(this.$el, this.$props.options);
                formData.value = Object.assign({}, (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getData());
                (_b = this.formInstance) === null || _b === void 0 ? void 0 : _b.on("submitted", () => {
                    var _a, _b;
                    this.$emit('submitted', (_b = (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getData()) !== null && _b !== void 0 ? _b : null);
                }, true);
                (_c = this.formInstance) === null || _c === void 0 ? void 0 : _c.on("resetted", () => {
                    this.$emit('resetted');
                }, true);
                (_d = this.formInstance) === null || _d === void 0 ? void 0 : _d.on("dataUpdated", () => {
                    var _a, _b, _c;
                    formData.value = (_b = Object.assign({}, (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.getData())) !== null && _b !== void 0 ? _b : null;
                    this.$emit('dataUpdated', (_c = formData.value) !== null && _c !== void 0 ? _c : null);
                }, true);
                (_e = this.formInstance) === null || _e === void 0 ? void 0 : _e.on("validationFailedOnSubmit", () => {
                    this.$emit('validationFailed');
                }, true);
            });
        },
        isRenderable(param) {
            return param && typeof param === 'object' && Object.prototype.hasOwnProperty.call(param, 'render');
        },
        acceptVNode(key, record, mutator = '') {
            if (record.id && this.isRenderable(record[key])) {
                const renderer = record[key];
                record[key] = () => {
                    const div = document.createElement('div');
                    (0, vue_1.createApp)({
                        render: () => (0, vue_1.h)(renderer, { data: formData.value }),
                    }).mount(div);
                    return div;
                };
            }
        },
        resolveVNodes(parent) {
            return __awaiter(this, void 0, void 0, function* () {
                if (parent.schema) {
                    const schema = parent.schema;
                    parent.schema = yield Promise.all(schema.map((record) => __awaiter(this, void 0, void 0, function* () {
                        this.acceptVNode('label', record, '_label');
                        this.acceptVNode('template', record);
                        if (record.shcema) {
                            record = yield this.resolveVNodes(record);
                        }
                        return record;
                    })));
                }
                return parent;
            });
        },
    },
    render() {
        return (0, vue_1.h)('div');
    },
    computed: {
        data() {
            return formData.value;
        },
    },
    mounted() {
        var _a;
        (0, core_1.usePlugin)((_a = this.$props.plugins) !== null && _a !== void 0 ? _a : []);
        if (this.$props.licenseKey) {
            (0, core_1.setLicenseKey)(this.$props.licenseKey);
        }
        this.initForm();
    },
    beforeUnmount() {
        var _a;
        (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.destroy();
    },
    watch: {
        options: {
            handler: function () {
                var _a;
                (_a = this.formInstance) === null || _a === void 0 ? void 0 : _a.destroy();
                this.initForm();
            },
            deep: true,
        },
    },
    emits: {
        submitted: (data) => true,
        resetted: () => true,
        dataUpdated: (data) => true,
        validationFailed: () => true,
    },
});
exports.default = FormComponent;
